Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 675)
+++ src/mlx/gui/flight.py	(revision 719)
@@ -1660,4 +2473,6 @@
             self._wizard.gui.beginBusy(xstr("fuel_pump_busy"))
             self._pump()
+        elif self._wizard.usingSimBrief:
+            self._wizard.jumpPage(3)
         else:
             self._wizard.nextPage()
@@ -1705,5 +2520,14 @@
         if fuelTank is None:
             self._wizard.gui.endBusy()
-            self._wizard.nextPage()
+            if self._wizard.usingSimBrief:
+                self._wizard.gui.startMonitoring()
+                self._wizard.jumpPage(3)
+            else:
+                bookedFlight = self._wizard._bookedFlight
+                self._wizard.gui.beginBusy(xstr("route_down_notams"))
+                self._wizard.gui.webHandler.getNOTAMs(self._notamsCallback,
+                                                      bookedFlight.departureICAO,
+                                                      bookedFlight.arrivalICAO)
+                startSound(const.SOUND_NOTAM)
         else:
             currentLevel = fuelTank.currentWeight / fuelTank.capacity
@@ -1719,151 +2543,4 @@
                                                       currentLevel)])
             gobject.timeout_add(50, self._pump)
-
-#-----------------------------------------------------------------------------
-
-class RoutePage(Page):
-    """The page containing the route and the flight level."""
-    def __init__(self, wizard):
-        """Construct the page."""
-        super(RoutePage, self).__init__(wizard, xstr("route_title"),
-                                        xstr("route_help"),
-                                        completedHelp = xstr("route_chelp"))
-
-        alignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
-                                  xscale = 0.0, yscale = 0.0)
-
-        mainBox = gtk.VBox()
-        alignment.add(mainBox)
-        self.setMainWidget(alignment)
-
-        levelBox = gtk.HBox()
-
-        label = gtk.Label(xstr("route_level"))
-        label.set_use_underline(True)
-        levelBox.pack_start(label, True, True, 0)
-
-        self._cruiseLevel = gtk.SpinButton()
-        self._cruiseLevel.set_increments(step = 10, page = 100)
-        self._cruiseLevel.set_range(min = 0, max = 500)
-        self._cruiseLevel.set_tooltip_text(xstr("route_level_tooltip"))
-        self._cruiseLevel.set_numeric(True)
-        self._cruiseLevel.connect("changed", self._cruiseLevelChanged)
-        self._cruiseLevel.connect("value-changed", self._cruiseLevelChanged)
-        label.set_mnemonic_widget(self._cruiseLevel)
-
-        levelBox.pack_start(self._cruiseLevel, False, False, 8)
-
-        alignment = gtk.Alignment(xalign = 0.0, yalign = 0.5,
-                                  xscale = 0.0, yscale = 0.0)
-        alignment.add(levelBox)
-
-        mainBox.pack_start(alignment, False, False, 0)
-
-
-        routeBox = gtk.VBox()
-
-        alignment = gtk.Alignment(xalign = 0.0, yalign = 0.5,
-                                  xscale = 0.0, yscale = 0.0)
-        label = gtk.Label(xstr("route_route"))
-        label.set_use_underline(True)
-        alignment.add(label)
-        routeBox.pack_start(alignment, True, True, 0)
-
-        routeWindow = gtk.ScrolledWindow()
-        routeWindow.set_size_request(400, 80)
-        routeWindow.set_shadow_type(gtk.ShadowType.IN if pygobject
-                                    else gtk.SHADOW_IN)
-        routeWindow.set_policy(gtk.PolicyType.AUTOMATIC if pygobject
-                               else gtk.POLICY_AUTOMATIC,
-                               gtk.PolicyType.AUTOMATIC if pygobject
-                               else gtk.POLICY_AUTOMATIC)
-
-        self._uppercasingRoute = False
-
-        self._route = gtk.TextView()
-        self._route.set_tooltip_text(xstr("route_route_tooltip"))
-        self._route.set_wrap_mode(WRAP_WORD)
-        self._route.get_buffer().connect("changed", self._routeChanged)
-        self._route.get_buffer().connect_after("insert-text", self._routeInserted)
-        routeWindow.add(self._route)
-
-        label.set_mnemonic_widget(self._route)
-        routeBox.pack_start(routeWindow, True, True, 0)
-
-        mainBox.pack_start(routeBox, True, True, 8)
-
-        self.addCancelFlightButton()
-
-        self._backButton = self.addPreviousButton(clicked = self._backClicked)
-        self._button = self.addNextButton(clicked = self._forwardClicked)
-
-    @property
-    def filedCruiseLevel(self):
-        """Get the filed cruise level."""
-        return self._cruiseLevel.get_value_as_int()
-
-    @property
-    def route(self):
-        """Get the route."""
-        return self._getRoute()
-
-    def activate(self):
-        """Setup the route from the booked flight."""
-        self._cruiseLevel.set_value(0)
-        self._cruiseLevel.set_text("")
-        self._route.get_buffer().set_text(self._wizard._bookedFlight.route)
-        self._updateForwardButton()
-
-    def _getRoute(self):
-        """Get the text of the route."""
-        buffer = self._route.get_buffer()
-        return buffer.get_text(buffer.get_start_iter(),
-                               buffer.get_end_iter(), True)
-
-    def _updateForwardButton(self):
-        """Update the sensitivity of the forward button."""
-        cruiseLevelText = self._cruiseLevel.get_text()
-        cruiseLevel = int(cruiseLevelText) if cruiseLevelText else 0
-        self._button.set_sensitive(cruiseLevel>=50 and self._getRoute()!="")
-
-    def _cruiseLevelChanged(self, *arg):
-        """Called when the cruise level has changed."""
-        self._updateForwardButton()
-
-    def _routeChanged(self, textBuffer):
-        """Called when the route has changed."""
-        if not self._uppercasingRoute:
-            self._updateForwardButton()
-
-    def _routeInserted(self, textBuffer, iter, text, length):
-        """Called when new characters are inserted into the route.
-
-        It uppercases all characters."""
-        if not self._uppercasingRoute:
-            self._uppercasingRoute = True
-
-            iter1 = iter.copy()
-            iter1.backward_chars(length)
-            textBuffer.delete(iter, iter1)
-
-            textBuffer.insert(iter, text.upper())
-
-            self._uppercasingRoute = False
-
-    def _backClicked(self, button):
-        """Called when the Back button is pressed."""
-        self.goBack()
-
-    def _forwardClicked(self, button):
-        """Called when the Forward button is clicked."""
-        if self._completed:
-            self._wizard.nextPage()
-        else:
-            bookedFlight = self._wizard._bookedFlight
-            self._wizard.gui.beginBusy(xstr("route_down_notams"))
-            self._wizard.gui.webHandler.getNOTAMs(self._notamsCallback,
-                                                  bookedFlight.departureICAO,
-                                                  bookedFlight.arrivalICAO)
-            startSound(const.SOUND_NOTAM)
 
     def _notamsCallback(self, returned, result):
@@ -2338,5 +3015,8 @@
         self._updatingMETAR = False
 
-        self._runway.set_text("")
+        if self._wizard.takeoffRunway is None:
+            self._runway.set_text("")
+        else:
+            self._runway.set_text(self._wizard.takeoffRunway)
         self._runway.set_sensitive(True)
         self._sid.set_active(0)
@@ -2897,5 +3577,8 @@
         self._transition.set_sensitive(True)
 
-        self._runway.set_text("")
+        if self._wizard.landingRunway is None:
+            self._runway.set_text("")
+        else:
+            self._runway.set_text(self._wizard.landingRunway)
         self._runway.set_sensitive(True)
 
@@ -3578,7 +4261,11 @@
         self._payloadIndex = len(self._pages)
         self._pages.append(TimePage(self))
-        self._pages.append(FuelPage(self))
         self._routePage = RoutePage(self)
         self._pages.append(self._routePage)
+        self._simBriefSetupPage = SimBriefSetupPage(self)
+        self._pages.append(self._simBriefSetupPage)
+        self._simBriefingPage = SimBriefingPage(self)
+        self._pages.append(self._simBriefingPage)
+        self._pages.append(FuelPage(self))
         self._departureBriefingPage = BriefingPage(self, True)
         self._pages.append(self._departureBriefingPage)
@@ -3653,6 +4340,11 @@
         return self._loginResult
 
-    def setCurrentPage(self, index, finalize = False):
-        """Set the current page to the one with the given index."""
+    def setCurrentPage(self, index, finalize = False, fromPageShift = None):
+        """Set the current page to the one with the given index.
+
+        @param fromPageShift if given, the relative index of one of the
+        previous pages that should be used as the from-page of the next
+        page. E.g. if fromPageShift is 1, the previous page will be the
+        from-page."""
         assert index < len(self._pages)
 
@@ -3663,4 +4355,6 @@
                 page.complete()
             self.remove(page)
+            if fromPageShift is not None:
+                fromPage -= fromPageShift
 
         self._currentPage = index
@@ -3741,4 +4435,9 @@
 
     @property
+    def alternate(self):
+        """Get the ICAO code of the alternate airport."""
+        return self._routePage.alternate
+
+    @property
     def departureMETAR(self):
         """Get the METAR of the departure airport."""
@@ -3840,11 +4539,22 @@
         return self._finishPage.online
 
+    @property
+    def usingSimBrief(self):
+        """Indicate if we are using a SimBrief briefing or not."""
+        return self._usingSimBrief
+
+    @usingSimBrief.setter
+    def usingSimBrief(self, x):
+        """Set whether we are using a SimBrief briefing or not."""
+        self._usingSimBrief = x
+
     def nextPage(self, finalize = True):
         """Go to the next page."""
         self.jumpPage(1, finalize)
 
-    def jumpPage(self, count, finalize = True):
+    def jumpPage(self, count, finalize = True, fromPageShift = None):
         """Go to the page which is 'count' pages after the current one."""
-        self.setCurrentPage(self._currentPage + count, finalize = finalize)
+        self.setCurrentPage(self._currentPage + count,
+                            finalize = finalize, fromPageShift = fromPageShift)
 
     def grabDefault(self):
@@ -3895,4 +4605,7 @@
         self._arrivalNOTAMs = None
         self._arrivalMETAR = None
+        self._usingSimBrief = None
+        self.takeoffRunway = None
+        self.landingRunway = None
 
         firstPage = 0 if self._loginResult is None else 1
@@ -3938,9 +4651,9 @@
         metar = metar.upper()
         if originator in [self._departureBriefingPage, self._takeoffPage]:
-            self._departureMETARChanged(metar, originator)
+            self.departureMETARChanged(metar, originator)
         else:
-            self._arrivalMETARChanged(metar, originator)
-
-    def _departureMETARChanged(self, metar, originator):
+            self.arrivalMETARChanged(metar, originator)
+
+    def departureMETARChanged(self, metar, originator):
         """Called when the departure METAR has been edited on one of the
         pages.
@@ -3952,5 +4665,5 @@
                 page.changeMETAR(metar)
 
-    def _arrivalMETARChanged(self, metar, originator):
+    def arrivalMETARChanged(self, metar, originator):
         """Called when the arrival METAR has been edited on one of the
         pages.
Index: src/mlx/gui/gui.py
===================================================================
--- src/mlx/gui/gui.py	(revision 620)
+++ src/mlx/gui/gui.py	(revision 687)
@@ -15,4 +15,6 @@
 from mlx.gui.pirep import PIREPViewer
 from mlx.gui.bugreport import BugReportDialog
+from mlx.gui.acars import ACARS
+import cef
 
 import mlx.const as const
@@ -102,6 +104,9 @@
         window.connect("delete-event", self.deleteMainWindow)
         window.connect("window-state-event", self._handleMainWindowState)
+        if os.name=="nt":
+            window.connect("leave-notify-event", self._handleLeaveNotify)
         accelGroup = gtk.AccelGroup()
         window.add_accel_group(accelGroup)
+        window.realize()
 
         mainVBox = gtk.VBox()
@@ -151,4 +156,9 @@
         self._notebook.append_page(self._fleetGateStatus, label)
 
+        self._acars = ACARS(self)
+        label = gtk.Label("ACARS")
+        label.set_use_underline(True)
+        self._notebook.append_page(self._acars, label)
+
         (self._debugLogWidget, self._debugLogView) = self._buildLogWidget()
         self._debugLogWidget.show_all()
@@ -170,4 +180,6 @@
 
         window.show_all()
+        if os.name=="nt":
+            window.get_window().focus()
 
         self._wizard.grabDefault()
@@ -427,11 +439,15 @@
             self._updater = Updater(self,
                                     self._programDirectory,
-                                    self.config.updateURL,
+                                    self.config.DEFAULT_UPDATE_URL,
                                     self._mainWindow)
             self._updater.start()
+
+        cef.initialize(self._programDirectory, self._cefInitialized)
 
         singleton.raiseCallback = self.raiseCallback
         gtk.main()
         singleton.raiseCallback = None
+
+        cef.finalize()
 
         self._disconnect()
@@ -688,4 +704,11 @@
             self._mainWindow.present()
 
+    def _handleLeaveNotify(self, widget, event):
+        """Handle the leave-notify event.
+
+        Here we reset the focus to the main window as CEF might have acquired
+        it earlier."""
+        self._mainWindow.get_window().focus()
+
     def raiseCallback(self):
         """Callback for the singleton handling code."""
@@ -788,4 +811,8 @@
         self._weightHelp.set_sensitive(False)
         self._mainWindow.get_window().set_cursor(self._busyCursor)
+        self._statusbar.updateBusyState(message)
+
+    def updateBusyState(self, message):
+        """Update the busy state."""
         self._statusbar.updateBusyState(message)
 
@@ -1464,4 +1491,9 @@
                                       summary, description, email)
 
+    def _cefInitialized(self):
+        """Called when CEF has been initialized."""
+        self._acars.start()
+        cef.initializeSimBrief()
+
     def _bugReportSentCallback(self, returned, result):
         """Callback function for the bug report sending result."""
Index: src/mlx/gui/mava_simbrief.py
===================================================================
--- src/mlx/gui/mava_simbrief.py	(revision 701)
+++ src/mlx/gui/mava_simbrief.py	(revision 701)
@@ -0,0 +1,390 @@
+# needed for os specific separators
+import os
+# selenium is needed for browser manipulation
+from selenium import webdriver
+from selenium.common.exceptions import NoSuchElementException
+from selenium.common.exceptions import NoSuchWindowException
+from selenium.webdriver.common.by import By
+from selenium.webdriver.support.ui import WebDriverWait, Select
+from selenium.webdriver.support import expected_conditions as EC
+from selenium.webdriver.common.keys import Keys
+# urllib is needed to obtain the xml
+import urllib2
+# xmlparser
+from lxml import etree
+from StringIO import StringIO
+import lxml.html
+import time
+
+
+class MavaSimbriefIntegrator():
+    """Implements the integration with the excellent Simbrief pilot briefing
+    system for MALEV Virtual."""
+
+    # Progress stage: searching the suitable browser window
+    PROGRESS_SEARCHING_BROWSER = 1
+
+    # Progress stage: retrieving the form from the server
+    PROGRESS_LOADING_FORM = 2
+
+    # Progress stage: filling the form
+    PROGRESS_FILLING_FORM = 3
+
+    # Progress stage: waiting for the login
+    PROGRESS_WAITING_LOGIN = 4
+
+    # Progress stage: logging in
+    PROGRESS_LOGGING_IN = 5
+
+    # Progress stage: waiting for result
+    PROGRESS_WAITING_RESULT = 6
+
+    # The maximal reserved progress stage
+    PROGRESS_MAX = 16
+
+    # Result code: none (i.e. the SimBrief query is in progress).
+    RESULT_NONE = 0
+
+    # Result code: success
+    RESULT_OK = 1
+
+    # Result code: other error
+    RESULT_ERROR_OTHER = 2
+
+    # Result code: form could not be loaded
+    RESULT_ERROR_NO_FORM = 11
+
+    # Result code: no popup (i.e. login) window found
+    RESULT_ERROR_NO_POPUP = 12
+
+    # Result code: login failed
+    RESULT_ERROR_LOGIN_FAILED = 13
+
+    # The maximal reserved result code
+    RESULT_MAX = 32
+
+    def __init__(self,
+                 plan,
+                 driver=None,
+                 simbrief_query_settings=None,
+                 mava_simbrief_url=None,
+                 xml_link_fix_part=None):
+        """Init the integrator with settings that are typical of our use.
+        @param: plan - flightplan dictionary
+        @param: webdriver - a selenium webdriver
+        @param: simbrief_query_settings - a dictionary of query settings
+        @param: mava_simbrief_url - url to the form that is sent to simbrief
+        on the mava server
+        @param: xml_link_fix_part = url to the simbrief website under which the
+        xml is to be found"""
+        self.plan = plan
+        if simbrief_query_settings is None:
+            self.simbrief_query_settings = {
+                'navlog': True,
+                'etops': True,
+                'stepclimbs': True,
+                'tlr': True,
+                'notams': True,
+                'firnot': True,
+                'maps': 'Simple',
+            }
+        else:
+            self.simbrief_query_settings = simbrief_query_settings
+
+        if driver is None:
+            self.driver = webdriver.Firefox()
+        else:
+            self.driver = driver
+
+        if mava_simbrief_url is None:
+            self.mava_simbrief_url = "http://flare.privatedns.org/" \
+                                     "mava_simbrief/simbrief_form.html"
+        else:
+            self.mava_simbrief_url = mava_simbrief_url
+
+        if xml_link_fix_part is None:
+            self.xml_link_fix_part = "http://www.simbrief.com/ofp/" \
+                                     "flightplans/xml/"
+        else:
+            self.xml_link_fix_part = xml_link_fix_part
+
+    def fill_form(self,
+                  plan,
+                  simbrief_query_settings):
+        """Fills the form of the webpage using the paramteres that the class
+        has been initialized with.
+        @param: driver - a selenium webdriver
+        @param: plan - dictionary containing plan details
+        @param: simbrief_query_settings - dictionary containing plan settings"""
+        for plan_input_field in plan.iterkeys():
+            self.driver.find_element_by_name(plan_input_field).send_keys(
+                plan[plan_input_field])
+        for option_checkbox in simbrief_query_settings.iterkeys():
+            if (isinstance(simbrief_query_settings[option_checkbox], bool) and
+                    simbrief_query_settings[option_checkbox]):
+                # if setting is a boolean type and true
+                self.driver.find_element_by_name(option_checkbox).click()
+            elif isinstance(simbrief_query_settings[option_checkbox], str):
+                # if setting is a select
+                Select(self.driver.find_element_by_name(option_checkbox)).\
+                    select_by_visible_text(simbrief_query_settings[
+                    option_checkbox])
+
+    def get_xml_link(self,
+                     get_credentials, update_progress,
+                     local_xml_debug=False,
+                     local_html_debug=False):
+        """Obtains the link of the xml to be processed.
+        @param get_credentials - a function, which should return a pair of the
+        user name and password to log in to SimBrief. It gets an integer which
+        is the number of times it has been called so far.
+        @param local_xml_debug - if True then not the real location will be
+        checked but the current working dir will be searched for 'xml.xml'
+        @param local_html_debug - if True then not real mava_simbrief_url will
+        be used but the current working dir will be searched for
+        'mava_simbrief.html'
+        @returns: the string of the xml link if it could be obtained and None
+        otherwise"""
+        # Finding xml_link
+        is_briefing_available = False
+        if local_xml_debug:
+            # set link for locally debugging an existing xml file
+            xml_link = ("file://"
+                        + os.getcwd()
+                        + os.sep
+                        + "xml.xml")
+            is_briefing_available = True
+        else:
+            update_progress(MavaSimbriefIntegrator.PROGRESS_SEARCHING_BROWSER,
+                            MavaSimbriefIntegrator.RESULT_NONE, None)
+            # There must be window whose title is 'SimBrief' so that we
+            # could find our one among several
+            if self._find_window_by_title("SimBrief") is None:
+                print "No SimBrief window was found!"
+                update_progress(MavaSimbriefIntegrator.PROGRESS_SEARCHING_BROWSER,
+                                MavaSimbriefIntegrator.RESULT_ERROR_OTHER, None)
+                return None
+
+            # normal operation with a real xml file
+            update_progress(MavaSimbriefIntegrator.PROGRESS_LOADING_FORM,
+                            MavaSimbriefIntegrator.RESULT_NONE, None)
+            if local_html_debug:
+                self.driver.get(
+                    "file://" + os.getcwd() + os.sep + "simbrief_form.html")
+                is_briefing_available = True
+            else:
+                self.driver.get(self.mava_simbrief_url)
+
+            main_handle = self._find_window_by_title("Malev Virtual Simbrief Integration System")
+            if main_handle is None:
+                print "No SimBrief Integration window was found!"
+                update_progress(MavaSimbriefIntegrator.PROGRESS_LOADING_FORM,
+                                MavaSimbriefIntegrator.RESULT_ERROR_NO_FORM, None)
+                return None
+
+            # Make a copy of the window handles before submitting the form,
+            # so that we could find the popup
+            handles = self.driver.window_handles[:]
+
+            # Entering form data
+            update_progress(MavaSimbriefIntegrator.PROGRESS_FILLING_FORM,
+                            MavaSimbriefIntegrator.RESULT_NONE, None)
+            self.driver.switch_to_window(main_handle)
+            self.fill_form(self.plan,
+                           self.simbrief_query_settings)
+
+            # Loading page
+            button = self.driver.find_element_by_name("submitform")
+            button.send_keys(Keys.RETURN)
+
+            update_progress(MavaSimbriefIntegrator.PROGRESS_WAITING_LOGIN,
+                            MavaSimbriefIntegrator.RESULT_NONE, None)
+            popup_handle = self._find_popup(handles)
+            if popup_handle is None:
+                update_progress(MavaSimbriefIntegrator.PROGRESS_WAITING_LOGIN,
+                                MavaSimbriefIntegrator.RESULT_ERROR_NO_POPUP, None)
+                return None
+
+            login_count = 0
+            end_time = time.time() + 120.0
+            while not is_briefing_available and end_time > time.time():
+                try:
+                    self.driver.switch_to.window(popup_handle)
+
+                    userElement = self.driver.find_element_by_name("user")
+
+                    if userElement is not None:
+                        update_progress(MavaSimbriefIntegrator.PROGRESS_LOGGING_IN,
+                                        MavaSimbriefIntegrator.RESULT_NONE, None)
+                        (userName, password) = get_credentials(login_count)
+                        end_time = time.time() + 120.0
+                        if userName is None or password is None:
+                            update_progress(MavaSimbriefIntegrator.PROGRESS_WAITING_LOGIN,
+                                            MavaSimbriefIntegrator.RESULT_ERROR_LOGIN_FAILED, None)
+                            return None
+
+                        userElement.send_keys(userName)
+                        self.driver.find_element_by_name("pass").send_keys(password)
+                        self.driver.find_element_by_name("staylogged").click()
+
+                        self.driver.find_element(By.XPATH,
+                                                "//input[@value='Login']").send_keys(Keys.RETURN)
+                        login_count += 1
+                except NoSuchElementException:
+                    pass
+                except NoSuchWindowException:
+                    pass
+
+                update_progress(MavaSimbriefIntegrator.PROGRESS_WAITING_RESULT,
+                                MavaSimbriefIntegrator.RESULT_NONE, None)
+                self.driver.switch_to.window(main_handle)
+                try:
+                    if self.driver.find_element_by_name("hidden_is_briefing_available") is not None:
+                        is_briefing_available = True
+                        xml_link_element = self.driver.find_element_by_name(
+                            'hidden_link')
+                        xml_link_generated_part = xml_link_element.get_attribute(
+                            'value')
+                        xml_link = self.xml_link_fix_part + xml_link_generated_part + '.xml'
+                        print(xml_link)
+                except NoSuchElementException:
+                    pass
+
+        if is_briefing_available:
+            return xml_link
+        else:
+            update_progress(MavaSimbriefIntegrator.PROGRESS_WAITING_RESULT,
+                            MavaSimbriefIntegrator.RESULT_ERROR_OTHER, None)
+            return None
+
+    def get_results(self,
+                    xml_link,
+                    html_file_path = None):
+        """Parses the xml for information.
+        @param xml_link - a path to the xml file
+        @return a dictionary of the found information"""
+        # Setup variables
+        ## Holds analysis data not used
+        available_info = {}
+        ## Holds analysis data to be used
+        flight_info = {}
+        ## Holds notams
+        notams_list = []
+        ## Notam counter
+        i = 0
+        # Obtaining the xml
+        response = urllib2.urlopen(xml_link)
+        xml_content = response.read()
+        # Processing xml
+        tree = etree.parse(StringIO(xml_content))
+        context = etree.iterparse(StringIO(xml_content))
+        for action, element in context:
+            # Processing tags that occur multiple times
+            ## NOTAMS
+            if element.tag == 'notamdrec':
+                notams_element_list = list(element)
+                notam_dict = {}
+                for notam in notams_element_list:
+                    notam_dict[notam.tag] = notam.text
+                notams_list.append(notam_dict)
+                i += 1
+            ## WEATHER
+            elif element.tag == 'weather':
+                weather_element_list = list(element)
+                for weather in weather_element_list:
+                    flight_info[weather.tag] = weather.text
+            else:
+                available_info[element.tag] = element.text
+        # Processing plan_html
+        ## Obtaining chart links
+        image_links = []
+        for image_link_a_element in lxml.html.find_class(
+                available_info['plan_html'], 'ofpmaplink'):
+            for image_link_tuple in image_link_a_element.iterlinks():
+                if image_link_tuple[1] == 'src':
+                    image_links.append(image_link_tuple[2])
+        flight_info['image_links'] = image_links
+        print(sorted(available_info.keys()))
+        if html_file_path is None:
+            html_file_path = 'simbrief_plan.html'
+        with open(html_file_path, 'w') as f:
+            f.write(available_info['plan_html'])
+        return flight_info
+
+    def _find_window_by_title(self, title, timeout = 10.0):
+        """Find the window with the given title.
+
+        Switch to that window and return its handle."""
+        def predicate(handle):
+            self.driver.switch_to.window(handle)
+            return self.driver.title == title
+
+        return self._find_window(predicate, timeout = timeout)
+
+    def _find_popup(self, handles, timeout = 10.0):
+        """Find a popup, i.e. a new window being created.
+
+        handles is a list of window handles that existed before the popup was
+        expected to be created. If a new handle is found, that is assumed to be
+        the popup window."""
+        return self._find_window(lambda handle: handle not in handles,
+                                 timeout = timeout)
+
+    def _find_window(self, predicate, timeout = 10.0):
+        """Find a window that fulfills the given predicate."""
+        window_handle = None
+        end_time = time.time() + timeout
+        while window_handle is None and end_time > time.time():
+            for handle in self.driver.window_handles:
+                if predicate(handle):
+                    window_handle = handle
+                    break
+
+        return window_handle
+
+if __name__ == "__main__":
+    mava_simbrief_url = "http://flare.privatedns.org/" \
+                        "mava_simbrief/simbrief_form.html"
+    xml_link_fix_part = "http://www.simbrief.com/ofp/" \
+                        "flightplans/xml/"
+    plan = {
+        'airline': 'MAH',
+        'fltnum': '764',
+        'type': 'B738',
+        'orig': 'LHBP',
+        'dest': 'LSZH',
+        'date': '25FEB15',
+        'deph': '20',
+        'depm': '00',
+        'route': 'GILEP DCT ARSIN UL851 SITNI UL856 NEGRA',
+        'steh': '22',
+        'stem': '05',
+        'reg': 'HA-LOC',
+        'fin': 'LOC',
+        'selcal': 'XXXX',
+        'pax': '100',
+        'altn': 'LSGG',
+        'fl': '36000',
+        'cpt': 'BALINT SZEBENYI',
+        'pid': 'P008',
+        'fuelfactor': 'P000',
+        'manualzfw': '42.7',
+        'addedfuel': '2.5',
+        'contpct': '0.05',
+        'resvrule': '45',
+        'taxiout': '10',
+        'taxiin': '4',
+        'cargo': '5.0',
+        'origrwy': '31L',
+        'destrwy': '34',
+        'climb': '250/300/78',
+        'descent': '80/280/250',
+        'cruise': 'LRC',
+        'civalue': 'AUTO',
+    }
+    integrator = MavaSimbriefIntegrator(plan=plan)
+    link = integrator.get_xml_link(local_xml_debug=False,
+                                   local_html_debug=False)
+    flight_info = integrator.get_results(link)
+    print(flight_info)
+
